"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = express;
function express(createMiddleware) {
  var middleware = createMiddleware({
    error: function error(err, req) {
      if (req) {
        req.__next(err);
      }
    },
    request: function request(req) {
      req.__next();
    }
  });
  return function (req, res, next) {
    req.__next = next;
    middleware.request(req, res);
  };
}
//# sourceMappingURL=express.js.map