'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = hapi;
function hapi(createMiddleware) {
  var middleware = createMiddleware({
    request: function request(req) {
      return req.__reply.continue();
    },
    error: function error(err, req) {
      if (req) {
        req.__reply(err);
      }
    }
  });
  return {
    type: 'onRequest',
    method: function method(request, reply) {
      var _request$raw = request.raw;
      var req = _request$raw.req;
      var res = _request$raw.res;

      req.__reply = reply;
      middleware.request(req, res);
    }
  };
}
//# sourceMappingURL=hapi.js.map