'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Detect current locales.
 * @param {Array} locales Supported locales.
 * @returns {Function} Middleware function.
 */

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var locales = _ref.locales;

  return function (app) {
    if (!locales) {
      return app;
    }
    var _request = app.request;

    return _extends({}, app, {
      request: function request(req, res) {
        req.locales = (0, _language2.default)(req.headers['accept-language'], locales);
        req.locale = req.locales[0];
        _request(req, res);
      }
    });
  };
};

var _language = require('negotiator/lib/language');

var _language2 = _interopRequireDefault(_language);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
//# sourceMappingURL=locale.js.map