'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _ref$logger = _ref.logger;
  var logger = _ref$logger === undefined ? dev : _ref$logger;

  return function (app) {
    var _request = app.request;
    var error = app.error;

    return _extends({}, app, {
      request: function request(req, res) {
        // Wait until before headers are sent in order to capture everything
        // that's gone on with the request. To correlate events you can use the
        // `tag` property.
        (0, _onFinished2.default)(res, function () {
          logger(req, res, function (err) {
            if (err) {
              error(err);
            }
          });
        });
        _request(req, res);
      }
    });
  };
};

var _morgan = require('morgan');

var _morgan2 = _interopRequireDefault(_morgan);

var _onFinished = require('on-finished');

var _onFinished2 = _interopRequireDefault(_onFinished);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Make mogan use the timing middleware we provide.
_morgan2.default.token('response-time', function (req, res, digits) {
  var ms = (res.timing.headers - req.timing.start) * 1e3;
  return ms.toFixed(digits === undefined ? 3 : digits);
});

// Since logging happens at the end of the request cycle, morgan does not need
// to install any of its own lifecycle hooks; therefore set the immediate flag.
var dev = (0, _morgan2.default)('dev', { immediate: true });
//# sourceMappingURL=logging.js.map