'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  _objectDestructuringEmpty(_ref);

  return function (app) {
    var nextError = app.error;

    function error(err, context) {
      // if error is a request error then try to display an error page
      if (context.req) {
        try {
          send(context.req, context.res, {
            status: err.status || 500
          });
        } catch (err) {
          nextError(err, context);
        }
      }
      nextError(err, context);
    }

    function send(req, res, _ref2) {
      var status = _ref2.status;
      var locale = _ref2.locale;
      var markup = _ref2.markup;

      res.statusCode = status;
      res.setHeader('Allow', 'GET');
      res.setHeader('Content-Type', 'text/html; charset="utf-8"');
      res.setHeader('Content-Language', locale);
      res.setHeader('X-UA-Compatible', 'IE=Edge,chrome=1');
      // TODO: .set('Content-Security-Policy', csp(result))

      res.end(markup);
    }

    return _extends({}, app, {
      error: error,
      request: function request(req, res) {
        // const store = createStore(reducer, createInitialState(req, res));
        var state = {};

        // Extract useful header information from react app state.
        send(req, res, state);
      }
    });
  };
};

function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure undefined"); }
//# sourceMappingURL=react.js.map