"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var _ref$request = _ref.request;
  var request = _ref$request === undefined ? function () {} : _ref$request;
  var _ref$error = _ref.error;
  var error = _ref$error === undefined ? function () {} : _ref$error;
  var _ref$createStore = _ref.createStore;
  var createStore = _ref$createStore === undefined ? function () {
    return {};
  } : _ref$createStore;
  var _ref$render = _ref.render;
  var render = _ref$render === undefined ? function () {} : _ref$render;
  return function (app) {
    var handleEvent = function handleEvent(mapArgs, handler) {
      return function () {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var _mapArgs = mapArgs.apply(undefined, args);

        var req = _mapArgs.req;
        var res = _mapArgs.res;

        var store = createStore();
        req.store = store;

        // Populate store state from request state
        handler.apply(undefined, args.concat([store]));

        return Promise.resolve().then(function () {
          return render(req, res, store);
        }).then(function (result) {
          req.render = result;
          req.body = result.markup;
          app.request(req, res);
        }).catch(function (err) {
          app.error(err, req, res);
        });
      };
    };

    return _extends({}, app, {
      error: handleEvent(function (err, req, res) {
        return { req: req, res: res };
      }, error),
      request: handleEvent(function (req, res) {
        return { req: req, res: res };
      }, request)
    });
  };
};
//# sourceMappingURL=render.js.map