'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * [function description]
                                                                                                                                                                                                                                                                   * @param {Boolean} secure True to enable security features.
                                                                                                                                                                                                                                                                   * @returns {Function} Middleware function.
                                                                                                                                                                                                                                                                   */

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _ref$secure = _ref.secure;
  var secure = _ref$secure === undefined ? false : _ref$secure;

  return function (app) {
    if (!secure) {
      return app;
    }
    var _request = app.request;

    return _extends({}, app, {
      request: function request(req, res) {
        // https://www.owasp.org/index.php/List_of_useful_HTTP_headers
        res.setHeader('Strict-Transport-Security', 'max-age=16070400');
        res.setHeader('X-Frame-Options', 'deny');
        res.setHeader('X-XSS-Protection', '1; mode=block');
        res.setHeader('X-Download-Options', 'noopen');
        res.setHeader('X-Content-Type-Options', 'nosniff');
        // res.setHeader('Public-Key-Pins', '...');
        _request(req, res);
      }
    });
  };
};
//# sourceMappingURL=secure.js.map