'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  return function (app) {
    var _request = app.request;

    return _extends({}, app, {
      request: function request(req, res) {
        req.timing = {};
        res.timing = {};
        req.timing.start = stamp();
        (0, _onFinished2.default)(req, function () {
          req.timing.end = stamp();
        });
        (0, _onHeaders2.default)(res, function () {
          res.timing.headers = stamp();
        });
        (0, _onFinished2.default)(res, function () {
          res.timing.end = stamp();
        });
        _request(req, res);
      }
    });
  };
};

var _onHeaders = require('on-headers');

var _onHeaders2 = _interopRequireDefault(_onHeaders);

var _onFinished = require('on-finished');

var _onFinished2 = _interopRequireDefault(_onFinished);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Get the current timestamp in seconds.
 * @returns {Number} Timestamp.
 */
function stamp() {
  var time = process.hrtime();
  return time[0] + time[1] * 1e-9;
}

/**
 * Attach timing information to the HTTP request and response objects. Note that
 * to use the timing results this function has to be called first in the
 * middleware chain.
 * @returns {Function} Middleware function.
 */
//# sourceMappingURL=timing.js.map