'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Attach an `agent` property containing useragent information.
 * @returns {Function} Middleware function.
 */

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  return function (app) {
    var _request = app.request;

    return _extends({}, app, {
      request: function request(req, res) {
        req.agent = (0, _useragent.lookup)(req.headers['user-agent']);
        _request(req, res);
      }
    });
  };
};

var _useragent = require('useragent');
//# sourceMappingURL=useragent.js.map